clear all;
   
% Kapasitetskontroll av betongskall, iterasjonsmetoden.

% Input
nx=4127;                                                                
ny=250;                                                                    
nxy=-464;
mx=-38;                                                                    
my=70;
mxy=3;

fck=65;
fyk=500;
gammac=1.5;
gammas=1.15;

Asx1=5570;                   
Asy1=1289;
Asx2=5365;                   
Asy2=1241;

alfa(1)=0;
alfa(2)=0; 

h=350;
c1=75;                       
c2=75;
n=10;

Esx1=200000;
Esx2=200000;
Esy1=200000;
Esy2=200000;

beta=0.001;
detaljer=0; 
stopp=1000;

% Verdier
R=[nx;ny;nxy;mx*1000;my*1000;mxy*1000];
Asx(1)=Asx1/1000;
Asx(2)=Asx2/1000;
Asy(1)=Asy1/1000;
Asy(2)=Asy2/1000;
Esx(1)=Esx1;
Esx(2)=Esx2;
Esy(1)=Esy1;
Esy(2)=Esy2;
x=2*beta;
beregnet=0; 
k=0; 

% Betongens egenskaper
fcd=(0.85*fck)/gammac;
fcm=fck+8;
Ecm=22000*(((fcm)/10)^0.3); 
Ecd=Ecm/1.0;
vc=0;
if fck <=50
    epsc2=2/1000;
    nc=2;
    epscu2=3.5/1000;
else epsc2=(2+0.085*(fck-50)^0.53)/1000;
     nc=1.4+23.4*((90- fck)/100)^4;
     epscu2=(2.6+35*(((90-fck)/100)^4))/1000;
end;

% Armeringens egenskaper
fyd=fyk/gammas;

% Indre momentarm for betong og armering
i=(1:n);
zci=(((h/n)*(i-1))+((h/n)/2)-(h/2));
if c1==0;
    zs(1)=0; 
else zs(1)=-((h/2)-c1);
end
if c2==0;
    zs(2)=0;
else zs(2)=(h/2)-c2;
end

% Detaljer
if detaljer==1
    R
    fcd
    fcm
    Ecm
    Ecd
    fyd
    zs
    zci
    epsc2
    nc
    epscu2
else fcd;fcm;Ecm;Ecd;fyd;zs;zci;epsc2;nc;epscu2;
end

% Den ytre loopen
while (max(abs(x)))>beta 
    
% Materialmatrise og stivhetsmatrise til betong og armering
 Cc0=((Ecd/(1-(vc^2)))*[1 vc 0;vc 1 0;0 0 ((1-vc)/2)]); 
 if beregnet==0
    Kc=((h/n)*[(n*Cc0) (-sum(zci)*Cc0);(-sum(zci)*Cc0) (sum(zci.*zci)*Cc0)]);
else Kc=[Cc zCc;zCc zzCc]; 
end

if beregnet==0
    Ksx=zeros(6,6);
    Ksy=zeros(6,6);
    for j=1:2;
      Csx0(:,:,j)=[Esx(j) 0 0;0 0 0;0 0 0];
      Csy0(:,:,j)=[0 0 0;0 Esy(j) 0;0 0 0];  
      Ksx0(:,:,j)=Asx(j)*[Csx0(:,:,j) (-(zs(j))*Csx0(:,:,j));(-(zs(j))*Csx0(:,:,j)) (((zs(j))^2)*Csx0(:,:,j))];
      Ksy0(:,:,j)=Asy(j)*[Csy0(:,:,j) (-(zs(j))*Csy0(:,:,j));(-(zs(j))*Csy0(:,:,j)) (((zs(j))^2)*Csy0(:,:,j))];
      Ksx(:,:)=Ksx+Ksx0(:,:,j);
      Ksy(:,:)=Ksy+Ksy0(:,:,j);
    end
else Ksx=[Csx zCsx;zCsx zzCsx];
     Ksy=[Csy zCsy;zCsy zzCsy];   
end
Ks=Ksx+Ksy;

% Tverrsnittets stivhetsmatrise 
K=Kc+Ks;

% Tyning og krumning i midtplanet til skalltverrsnittet
epst=(K^-1)*R;
if isnan(epst);
      epst=pinv(K)*R;
else epst;
end
e=rcond(K^-1);
if isnan(e);
   epst;
else  epst=pinv(K)*R;
end

% Detaljer
if detaljer==2;
    if beregnet==0; 
        Cc0
        Csx0
        Csy0
    else Cck
        Csxk
        Csyk
    end
    Kc
    Ks
    K
    R 
    epst
else
    if beregnet==0; 
        Cc0;Csx0;Csy0;
    else Cck;Csx;Csy;
    end
    Kc;Ks;K;R;epst;
end

% Tyninger og spenninger i betonglamellene
for i=(1:n)
    Aci(:,:,i)=[1 0 0 -zci(i) 0 0;0 1 0 0 -zci(i) 0;0 0 1 0 0 -zci(i)];   
    epsci(:,i)=Aci(:,:,i)*epst;
    
    epscxi=epsci(1,i);               
    epscyi=epsci(2,i);
    gammacxyi=epsci(3,i);
    if (epscxi-epscyi)==0;
        thetaci(:,i)=0;
    else thetaci(:,i)=0.5*(atan(gammacxyi/(epscxi-epscyi)));
    end
    cc=cos(thetaci(:,i));
    sc=sin(thetaci(:,i));
    Tepscithetaci(:,:,i)=[cc^2 sc^2 sc*cc;sc^2 cc^2 -sc*cc;-2*sc*cc 2*sc*cc (cc^2)-(sc^2)];
    
    epspci(:,i)=Tepscithetaci(:,:,i)*epsci(:,i);   
    
    for p=1:2;
        etaci(p,i)=epspci(p,i)/-epsc2;
        if ((0>=epspci(p,i)) && (epspci(p,i)>=(-epsc2)));
            sigpci(p,i)=-fcd*(1-(1-etaci(p,i))^nc);
        elseif (((-epsc2)>epspci(p,i)) && (epspci(p,i)>=(-epscu2)));
                sigpci(p,i)=-fcd;
        else sigpci(p,i)=0;
        end
    end
    sigpci(3,i)=0;
  
    sigci(:,i)=transpose(Tepscithetaci(:,:,i))*sigpci(:,i);
end

% Detaljer
if detaljer==3;
        Aci
        epsci
        thetaci
        Tepscithetaci
        epspci
        sigpci
        sigci
    else Aci;epsci;thetaci;Tepscithetaci;epspci;sigpci;sigci;
end

% Betongens bidrag til den indre kraftvektoren
Sc=zeros(6,1);
  for i=1:n
  sc(1,1,i) = (h/n)*sigci(1,i);
  sc(2,1,i) = (h/n)*sigci(2,i);
  sc(3,1,i) = (h/n)*sigci(3,i);
  sc(4,1,i) = (h/n)*sigci(1,i)*-zci(i);
  sc(5,1,i) = (h/n)*sigci(2,i)*-zci(i);
  sc(6,1,i) = (h/n)*sigci(3,i)*-zci(i);
  Sc(:,1) = Sc + sc(:,1,i);
end
 Sc 
 
 % Tyninger og spenninger i armeringene
for j=(1:2);
    if zs(j)==0
        Asj(:,:,j)=zeros(6,3);
    else Asj(:,:,j)=[1 0 0 -zs(j) 0 0;0 1 0 0 -zs(j) 0;0 0 1 0 0 -zs(j)];
    end
    epssj(:,j)=Asj(:,:,j)*epst;
    
    alfasj=((alfa(j)/180)*pi);
    cs=cos(alfasj);
    ss=sin(alfasj);
    Tepssjalfasj(:,:,j)=[cs^2 ss^2 ss*cs;ss^2 cs^2 -ss*cs;-2*ss*cs 2*ss*cs (cs^2)-(ss^2)];  
    
    epspsj(:,j)=Tepssjalfasj(:,:,j)*epssj(:,j);
   
    if abs(epspsj(1,j))<= fyd/Esx(j);
        sigpsj(1,j)=epspsj(1,j)*Esx(j);
    else sigpsj(1,j)=(epspsj(1,j)/abs(epspsj(1,j)))*fyd;
    end
    if abs(epspsj(2,j))<= fyd/Esy(j);
        sigpsj(2,j)=epspsj(2,j)*Esy(j);
    else sigpsj(2,j)=(epspsj(2,j)/abs(epspsj(2,j)))*fyd;
    end
    sigpsj(3,j)=0;
    
    sigsj(:,j)=transpose(Tepssjalfasj(:,:,j))*sigpsj(:,j);
end

% Detaljer
if detaljer==4;
    Asj
    epssj
    Tepssjalfasj
    epspsj
    sigpsj
    sigsj
else Asj;epssj;Tepssjalfasj;epspsj;sigpsj;sigsj; 
end

% Armeringens bidrag til den indre kraftvektoren
Ss=zeros(6,1);
for j=1:2
  ss(1,1,j) = Asx(j)*sigsj(1,j);
  ss(2,1,j) = Asy(j)*sigsj(2,j);
  ss(3,1,j) = 0;
  ss(4,1,j) = Asx(j)*-zs(j)*sigsj(1,j);
  ss(5,1,j) = Asy(j)*-zs(j)*sigsj(2,j);
  ss(6,1,j) = 0;
  Ss(:,1) = Ss + ss(:,1,j);
end
 Ss
 
% Den indre kraftvektoren
 S=(Sc+Ss);S
 
% Differansen mellom R og S
for r=1:6;
if R(r)==0;f(r)=0;
else f(r)=(R(r)-(S(r)))/R(r); 
end
x=f(1:r);
end
x

 % Betongens nye e-moduler og materialmatriser 
for i=(1:n)
    if epspci(1,i)==0;
        E11(:,i)=0;
    else E11(:,i)=sigpci(1,i)/epspci(1,i);
    end  
    
    if epspci(2,i)==0;
        E22(:,i)=0;
    else E22(:,i)=sigpci(2,i)/epspci(2,i);
    end
 
    E12(:,i)=((E11(:,i)+E22(:,i))/2);
    
    cck(:,:,i)=(1/(1-vc^2))*[E11(:,i) vc*E12(:,i) 0;vc*E12(:,i) E22(:,i) 0;0 0 (((1-vc)*E12(:,i))/2)];
  
    Cck(:,:,i)=transpose(Tepscithetaci(:,:,i))*cck(:,:,i)*Tepscithetaci(:,:,i);                                                                                                      
end

% Detaljer
  if detaljer==5; 
        E11
        E22
        E12
        cck
        Cck
    else E11;E22;E12;cck;Cck;
  end
  
% Armeringenes nye e-moduler og materialmatriser
for j=(1:2)
    if epspsj(1,j)==0;
        Esx(:,j)=0;
    else Esx(:,j)=(sigpsj(1,j)/epspsj(1,j));
    end
    if epspsj(2,j)==0;
        Esy(:,j)=0;
    else Esy(:,j)=(sigpsj(2,j)/epspsj(2,j));
    end
   
    csxk(:,:,j)=[Esx(:,j) 0 0;0 0 0;0 0 0]; 
    csyk(:,:,j)=[0 0 0;0 Esy(:,j) 0;0 0 0]; 

    Csxk(:,:,j)=transpose(Tepssjalfasj(:,:,j))*csxk(:,:,j)*Tepssjalfasj(:,:,j);
    Csyk(:,:,j)=transpose(Tepssjalfasj(:,:,j))*csyk(:,:,j)*Tepssjalfasj(:,:,j);
end

% Detaljer
    if detaljer==7;
        Esx
        Esy
        csxk
        csyk
        Csxk
        Csyk
    else Esx;Esy;csxk;csyk;Csxk;Csyk;
    end  
    
% Verdier til den nye stivhetsmatrisen for betong 
Cc=zeros(3,3);
zCc=zeros(3,3);             
zzCc=zeros(3,3);    
  for i=1:n
      Cc=Cc+((h/n)*Cck(:,:,i));
      zCc=zCc+((h/n)*(-zci(i))*Cck(:,:,i));
      zzCc=zzCc+((h/n)*zci(i)*zci(i)*Cck(:,:,i));
  end
% Detaljer
if detaljer==6;
    Cc
    zCc
    zzCc
else Cc;zCc;zzCc;
end

% Verdier til de nye stivhetsmatrisene til armeringen  
Csx=zeros(3,3);
zCsx=zeros(3,3);
zzCsx=zeros(3,3);
Csy=zeros(3,3);
zCsy=zeros(3,3);
zzCsy=zeros(3,3);
  for j=1:2
      Csx=Csx+(Asx(j)*Csxk(:,:,j));
      zCsx=zCsx+(Asx(j)*(-zs(j))*Csxk(:,:,j));
      zzCsx=zzCsx+(Asx(j)*zs(j)*zs(j)*Csxk(:,:,j));
      Csy=Csy+(Asy(j)*Csyk(:,:,j));
      zCsy=zCsy+(Asy(j)*(-zs(j))*Csyk(:,:,j));
      zzCsy=zzCsy+(Asy(j)*zs(j)*zs(j)*Csyk(:,:,j));
  end
  
% Detaljer
if detaljer==8;
    Csx
    zCsx
    zzCsx
    Csy
    zCsy
    zzCsy
else Csx;zCsx;zzCsx;Csy;zCsy;zzCsy;
end


k=k+1;k
if k>stopp,break,end 
beregnet=1; 
 end

k

maksspenningibetonglokal=max(max(abs(sigpci)))

toyningiarmeringenlokal=epspsj
spenningiarmeringenlokal=sigpsj


plot(-sigci(1,:),(zci+(h/2)))
